from recognition import recording,speech_to_text,clear_character,key_phrases,connect_sentence,send_to_storage
import threading
import time
import csv
import json

i=0
data_lst=[]
num=0
main_text=''
key_phrases_dict={}



#recording_and_sending(filename,num): --録音したものを文字に起こしてdata_lstに順番に格納[{'text':text,'key_phrases':key_phrase_lst}]
#main_textには現時点でのつなぎ合わせたテキストが入っている
def recording_and_sending(filename,num):
    global i
    global data_lst
    global main_text
    global key_phrases_dict

    text=''
    lst=[]
    recording(filename,9.9)
    text=speech_to_text(filename)

    if text=='':
        i+=1
    else:
        lst=key_phrases(text)

    data_lst.append({})
    data_lst[num-1]['text']=text
    data_lst[num-1]['key_phrases']=lst

    #main_txtにテキストを代入
    if len(data_lst)==1:
        main_text=data_lst[0]['text']
    else:
        main_text=main_text[:-len(data_lst[num-2]['text'])]+connect_sentence(main_text[-len(data_lst[num-2]['text']):],data_lst[num-1]['text'])

    #key_phrases_dictにキーワードを挿入
    for key_phrase in lst:
        if key_phrase not in key_phrases_dict:
            key_phrases_dict[key_phrase]=1
        else:
            key_phrases_dict[key_phrase]+=1

    #main_textとkey_phrases_dictをストレージに送る
    with open('main.txt','w') as f:
        f.write(main_text)
    send_to_storage('main.txt','txt')
    with open('key_phrases_dict.json','w') as f:
        json.dump(key_phrases_dict,f,ensure_ascii=False)
    send_to_storage('key_phrases_dict.json','json')

    #数回起きにファイルを表示
    if num%3==0:
        print('-'*15+'main_text'+'-'*30)
        print(main_text)
        print(key_phrases_dict)
        print('-'*40)


#一定回数送った音声ファイルからテキストが検出されなくなるまで、recording_and_sendingを繰り返す
while num<5:
    num+=1
    threadObj=threading.Thread(target=recording_and_sending,args=('sample{}.wav'.format(num%4),num))
    threadObj.start()
    time.sleep(6)













